package org.xbib.files.sftp.jadaptive.fs.spi;

import java.io.Closeable;
import java.io.IOException;
import java.net.URI;
import java.util.Map;

import org.xbib.files.sftp.jadaptive.fs.SftpFileSystem;
import org.xbib.files.sftp.jadaptive.fs.SftpFileSystemProvider;

public class SFTPContext implements Closeable {

    final SftpFileSystemProvider provider;

    final SftpFileSystem fileSystem;

    public SFTPContext(URI uri, Map<String, ?> env) throws IOException {
        this.sshClient = ClientBuilder.builder().build();
        Object object = env.get("workers");
        if (object instanceof Integer) {
            sshClient.setNioWorkers((Integer) object);
        } else if (object instanceof String) {
            sshClient.setNioWorkers(Integer.parseInt((String) object));
        } else {
            // we do not require a vast pool of threads
            sshClient.setNioWorkers(1);
        }
        sshClient.start();
        this.provider = new SftpFileSystemProvider(sshClient);
        this.fileSystem = provider.newFileSystem(uri, env);
    }

    @Override
    public void close() throws IOException {
        sshClient.stop();
        sshClient.close();
        fileSystem.close();
    }
}
